part of modern_form_core;

extension ModernFormDateTimeExtension on DateTime {
  static DateTime? fromMillisecondsSinceEpoch(dynamic millisecondsSinceEpoch) {
    try {
      if (millisecondsSinceEpoch != null) {
        if (millisecondsSinceEpoch is int) {
          return DateTime.fromMillisecondsSinceEpoch(millisecondsSinceEpoch);
        } else if (millisecondsSinceEpoch is String) {
          int year = int.parse(millisecondsSinceEpoch.substring(0, 4));
          int month = int.parse(millisecondsSinceEpoch.substring(5, 7));
          int day = int.parse(millisecondsSinceEpoch.substring(8, 10));
          int hour = int.parse(millisecondsSinceEpoch.substring(11, 13));
          int minute = int.parse(millisecondsSinceEpoch.substring(14, 16));

          return DateTime(year, month, day, (hour - 3), minute);
        } else {
          return null;
        }
      } else {
        return null;
      }
    } catch (e) {
      print("ERROR DateTimeExtension.fromMillisecondsSinceEpoch() --> $e");
      return null;
    }
  }

  DateTime copyWith({
    int? year,
    int? month,
    int? day,
    int? hour,
    int? minute,
    int? second,
    int? millisecond,
    int? microsecond,
  }) {
    return DateTime(
      year ?? this.year,
      month ?? this.month,
      day ?? this.day,
      hour ?? this.hour,
      minute ?? this.minute,
      second ?? this.second,
      millisecond ?? this.millisecond,
      microsecond ?? this.microsecond,
    );
  }
}
