part of modern_form_core;

extension ModernFormDurationExtension on Duration {
  String get toElegantString {
    if (this.inDays > 1) {
      Duration d = Duration(days: this.inDays);
      Duration diference = d - this;

      String days = "${this.inDays} dias";
      String hours = "${diference.abs().toRawString} horas";

      String v = "$days";
      if (diference.abs() > Duration()) {
        v += " e $hours";
      }

      return v;
    } else
      return "${this.toRawString} horas";
  }

  String get toRawString =>
      "${this.toHour.correctFormatTime}:${this.toMinute.correctFormatTime}";

  int get toHour {
    int hour = 0;
    int length = this.toString().length;

    if (length == 16) {
      hour = int.parse(this.toString().substring(0, 3).toString());
    } else if (length == 14) {
      hour = int.parse(this.toString().substring(0, 1).toString());
    } else {
      hour = int.parse(this.toString().substring(0, 2).toString());
    }
    return hour;
  }

  int get toMinute {
    int minute = 0;
    int length = this.toString().length;

    if (length == 14) {
      minute = int.parse(this.toString().substring(2, 4).toString());
    } else if (length == 15) {
      minute = int.parse(this.toString().substring(3, 5).toString());
    } else if (length == 16) {
      minute = int.parse(this.toString().substring(4, 6).toString());
    }
    return minute;
  }

  int get toValueString => this.inMicroseconds;
}

extension IntToDuration on int {
  Duration get toDuration => Duration(microseconds: this);

  String get correctFormatTime {
    String t = this.toString();
    if (t.length < 2) {
      t = "0$t";
    }
    return t;
  }
}
