part of modern_form_core;

extension ModernFormListExtension<E> on List<E>? {
  List<E> customAddAll(List<E> value) {
    List<E> _itens = List<E>.from(this ?? []);
    _itens.addAll(value);
    return _itens;
  }

  void removeAll(List<E> value) {
    for (var item in value) {
      this?.remove(item);
    }
  }

  List<E> customRemoveAll(List<E> value) {
    List<E> _itens = List<E>.from(this ?? []);
    _itens.removeAll(value);

    return _itens;
  }

  void customForEach(void f(E? element, int index)) {
    for (var i = 0; i < (this?.length ?? 0); i++) {
      E? e = this?[i];
      f(e, i);
    }
  }

  E? get customFirst => this.isNotNullAndNotEmpty ? this?.first : null;
  E? get customLast => this.isNotNullAndNotEmpty ? this?.last : null;

  List<T> customMap<T>(T? toResult(E e)) {
    List<T> newList = <T>[];

    this?.forEach((element) {
      T? result = toResult(element);
      if (result != null) {
        newList.add(result);
      }
    });

    return newList;
  }

  bool containsAny(List<E> elements) {
    if (this == null) {
      return false;
    }

    bool value = false;

    for (var i = 0; (!value && (i < elements.length)); i++) {
      E element = elements[i];
      value = this!.contains(element);
    }

    return value;
  }
}
