part of modern_form_core;

Future<void> dialogError(
  dynamic error, {
  StackTrace? stackTrace,
  bool? disableLog,
  String? message,
}) {
  String _cancelButtonText = "Fechar";
  String _okButtonText = "Compartilhar erro";
  String _titleText = "Erro";
  String _contentText =
      "Por favor compartilhe este relatório. Ocorreu o seguinte erro: ERROR ==> $error";

  String _message = "";
  if (message != null) _message += "$message ";
  _message += "$error";

  void onTapOk() {
    String text = 'Relatório de erros: $_message --> ${stackTrace ?? ""}';

    if (kIsWeb) {
      Clipboard.setData(ClipboardData(text: text));
      showFlushBar(value: true, textTrue: "Texto copiado");
    } else {
      ModernFormShareHelper.text(
        text,
        subject: "Compartilhar relatório de erro",
      );
    }
  }

  if (disableLog != false) {
    developer.log(
      _message,
      error: e,
      stackTrace: stackTrace,
    );
  }

  return dialog(
    titleText: _titleText,
    contentText: _contentText,
    cancelButtonText: _cancelButtonText,
    okButtonText: _okButtonText,
    onTapOk: onTapOk,
  );
}
