part of modern_form_core;

Future showModernFormDialog({
  required BuildContext context,
  required WidgetBuilder builder,
  bool barrierDismissible = true,
  Color? barrierColor = Colors.black54,
  String? barrierLabel,
  bool useSafeArea = true,
  bool useRootNavigator = true,
  RouteSettings? routeSettings,
}) {
  // assert(debugCheckHasMaterialLocalizations(context));

  CapturedThemes? themes;

  try {
    themes = InheritedTheme.capture(
      from: context,
      to: Navigator.of(context, rootNavigator: useRootNavigator).context,
    );
  } catch (e) {}

  return ModernFormNavigation.push(DialogRoute(
    context: context,
    builder: builder,
    barrierColor: barrierColor,
    barrierDismissible: barrierDismissible,
    barrierLabel: barrierLabel ?? "Dispensar",
    useSafeArea: useSafeArea,
    settings: routeSettings,
    themes: themes,
  ));
}
