// ignore_for_file: avoid_web_libraries_in_flutter

import 'dart:async';
import 'dart:convert';
import 'dart:js' as js;
import 'package:flutter/material.dart';
import 'package:share_plus/share_plus.dart';

class ShareHelperImplementation {
  static Future<void> text(
    String text, {
    String? subject,
    Rect? sharePositionOrigin,
  }) async {
    await Share.share(
      text,
      subject: subject,
      sharePositionOrigin: sharePositionOrigin,
    );
  }

  static Future<void> file(
    String title,
    String name,
    List<int> bytes,
    String mimeType, {
    String text = '',
  }) async {
    String b64 = base64.encode(bytes);
    js.context.callMethod('downloadBase64', [mimeType, b64, name]);
  }

  static Future<void> files(
    String title,
    Map<String, List<int>> files,
    String mimeType, {
    String text = '',
  }) async {
    Future<void> task(List<int> bytes, String name) async {
      String b64 = base64.encode(bytes);
      js.context.callMethod('downloadBase64', [mimeType, b64, name]);
    }

    files.forEach((key, value) {
      task(value, key);
    });
  }
}
