part of modern_form_core;

class ModernFormBottomSheetModel<T> {
  final String text;
  final T value;
  final Color? textColor;

  ModernFormBottomSheetModel({
    required this.text,
    required this.value,
    this.textColor,
  });

  ModernFormBottomSheetModel<T> copyWith({
    String? text,
    T? value,
    Color? textColor,
  }) {
    return ModernFormBottomSheetModel<T>(
      text: text ?? this.text,
      value: value ?? this.value,
      textColor: textColor ?? this.textColor,
    );
  }

  @override
  String toString() =>
      'ModernFormBottomSheetModel(text: $text, value: $value, textColor: $textColor)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is ModernFormBottomSheetModel<T> &&
        other.text == text &&
        other.value == value &&
        other.textColor == textColor;
  }

  @override
  int get hashCode => text.hashCode ^ value.hashCode ^ textColor.hashCode;
}
