part of modern_form_core;

class ModernFormUtils {
  static Color get primaryColor =>
      Theme.of(ModernFormGlobalContext.context!).primaryColor;
  static Color secundaryColor = Colors.blue;

  static String cpfMask = "000.000.000-00";
  static String cnpjMask = "00.000.000/0000-00";
  static String phoneMask = "(00) 0000 00000";

  static num webBreakdown = 768;

  static Size globalSize = MediaQuery.of(ModernFormGlobalContext.context!).size;
  static double deviceWidth = globalSize.width;
  static double deviceHeigth = globalSize.height;
  static bool isLargeDevice =
      kIsWeb && (deviceWidth > ModernFormUtils.webBreakdown);

  static TargetPlatform get platform =>
      Theme.of(ModernFormGlobalContext.context!).platform;
  static bool get isIos => platform == TargetPlatform.iOS;
  static bool get isAndroid => platform == TargetPlatform.android;
  static bool get isWindows => platform == TargetPlatform.windows;
  static bool get isLinux => platform == TargetPlatform.linux;
  static bool get isMacos => platform == TargetPlatform.macOS;

  static NumberFormat oCcy = NumberFormat.simpleCurrency(locale: "pt_BR");
  static DateFormat dateFormat = DateFormat('dd/MM/yyyy', 'pt_BR');
  static DateFormat timeFormat = DateFormat('jm', 'pt_BR');

  static String dateTimeFormat(DateTime? date, [String? separator]) {
    if (date == null) {
      return "";
    }
    return dateFormat.format(date) +
        " ${separator ?? 'às'} " +
        timeFormat.format(date) +
        " hrs";
  }

  static String dateTimeRangeFormat(DateTimeRange? period) {
    String periodFormated = "";

    if (period != null) {
      periodFormated = dateFormat.format(period.start);
    }

    if (period != null && period.end.year != 0) {
      periodFormated += " - ${dateFormat.format(period.end)}";
    }

    return periodFormated;
  }
}
