part of modern_form_core;

class ModernFormUpload extends StatelessWidget {
  final void Function()? onTap;
  final void Function(String url)? onChange;
  final bool? pasteEnabled;

  const ModernFormUpload({
    Key? key,
    this.onTap,
    this.pasteEnabled,
    this.onChange,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    bool isPasteEnabled = pasteEnabled != null && pasteEnabled!;

    return Row(
      mainAxisSize: MainAxisSize.min,
      children: [
        InkWell(
          onTap: onTap,
          child: Container(
            width: ScreenUtil().setWidth(80),
            height: ScreenUtil().setWidth(80),
            child: Material(
              elevation: 2,
              child: Icon(
                Icons.file_upload,
                color: Colors.black,
              ),
            ),
          ),
        ),
        isPasteEnabled
            ? Padding(
                padding: EdgeInsets.only(left: ScreenUtil().setWidth(15)),
                child: ModernFormPaste(onChange: onChange),
              )
            : Container(),
      ],
    );
  }
}
