part of modern_form_core;

class ModernFormFilterTextListItensDefault<T> extends StatelessWidget {
  final String? bottomSheetLabelText;
  final String? buttonText;
  final void Function(List<T> selecteds)? onChanged;
  final List<ModernFormBottomSheetModel<T>>? value;
  final Future<void> Function()? onTapAdd;
  final bool? moveEnable;

  const ModernFormFilterTextListItensDefault({
    Key? key,
    this.bottomSheetLabelText,
    this.onChanged,
    this.value,
    this.buttonText,
    this.onTapAdd,
    this.moveEnable,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    bool _moveEnable = moveEnable != null && moveEnable!;
    return Column(
      children: <Widget>[
        Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: <Widget>[
            ModernFormFilterTextListItens(
              itens: value!.map((e) => e.text).toList(),
              iconData: _moveEnable ? Icons.edit : null,
              onTapCloseIten: (index, c) async {
                List<ModernFormBottomSheetModel<T>> _s =
                    List<ModernFormBottomSheetModel<T>>.from(value!);

                if (_moveEnable) {
                  SecondOption? option = await showSecondOption(
                      c, [SecondOption.Move, SecondOption.Delete]);
                  if (option != null) {
                    switch (option) {
                      case SecondOption.Delete:
                        _s.removeAt(index);
                        break;
                      case SecondOption.Move:
                        int? newIndex =
                            await showMoveTo(c, (value?.length ?? 0), index);
                        if (newIndex != null) {
                          ModernFormBottomSheetModel<T> iten = _s[index];
                          _s.removeAt(index);
                          _s.insert(newIndex, iten);
                        }
                        break;
                      default:
                        break;
                    }
                  }
                } else {
                  _s.removeAt(index);
                }
                onChanged!(_s.map((e) => e.value).toList());
              },
            ),
            SizedBox(height: ScreenUtil().setHeight(7)),
            ElevatedButton.icon(
              label: Icon(Icons.add, size: ScreenUtil().setSp(18)),
              icon: Text(
                buttonText ?? "Adicionar",
                style: TextStyle(fontSize: ScreenUtil().setSp(14)),
              ),
              onPressed: onTapAdd,
            ),
          ],
        )
      ],
    );
  }
}
