import 'dart:async';
// ignore: avoid_web_libraries_in_flutter
import 'dart:html';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class ModernFormDetectorImplementation extends StatelessWidget {
  final GestureTapCallback? onTap;
  final Future<void> Function()? onLongPress;
  final Widget? child;
  final BorderRadius? borderRadius;

  const ModernFormDetectorImplementation({
    Key? key,
    this.onTap,
    this.onLongPress,
    this.child,
    this.borderRadius,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: onTap,
      borderRadius: borderRadius,
      child: GestureDetector(
        onSecondaryTap: () async {
          if (onLongPress != null) {
            StreamSubscription subscription = window.onContextMenu
                .listen((MouseEvent e) => e.preventDefault());
            await onLongPress!();
            await Future.delayed(Duration(seconds: 1));
            subscription.cancel();
          }
        },
        child: child ?? Container(),
      ),
    );
  }
}
