part of modern_form_core;

// ImageProvider? imageProviderWidget({
//   String? imageUrl,
//   Uint8List? imageMemory,
//   String? imageAsset,
//   String? assetPlaceHolder,
// }) =>
//     imageMemory != null && imageMemory.isNotEmpty
//         ? MemoryImage(imageMemory)
//         : (imageUrl != null && imageUrl.isNotEmpty
//             ? CachedNetworkImageProvider(imageUrl)
//             : imageAsset != null
//                 ? AssetImage(imageAsset)
//                 : assetPlaceHolder != null
//                     ? AssetImage(assetPlaceHolder)
//                     : null);

ImageProvider? imageProviderWidget({
  String? imageUrl,
  Uint8List? imageMemory,
  String? imageAsset,
  String? assetPlaceHolder,
}) {
  if (imageMemory != null && imageMemory.isNotEmpty) {
    return MemoryImage(imageMemory);
  } else if (imageUrl != null && imageUrl.isNotEmpty) {
    return CachedNetworkImageProvider(imageUrl);
  } else if (imageAsset != null && imageAsset.isNotEmpty) {
    return AssetImage(imageAsset);
  } else if (assetPlaceHolder != null && assetPlaceHolder.isNotEmpty) {
    return AssetImage(assetPlaceHolder);
  } else {
    return null;
  }
}

BehaviorSubject<ImageProvider> imageProviderStreamWidget({
  String? imageUrl,
  Uint8List? imageMemory,
  String? imageAsset,
  String? assetPlaceHolder,
}) {
  BehaviorSubject<ImageProvider> stream = BehaviorSubject<ImageProvider>();

  if (imageMemory != null && imageMemory.isNotEmpty) {
    stream.add(MemoryImage(imageMemory));
  } else if (imageUrl != null && imageUrl.isNotEmpty) {
    stream = imageProviderWidgetNetwork(imageUrl);
  } else if (imageAsset != null && imageAsset.isNotEmpty) {
    stream.add(AssetImage(imageAsset));
  } else if (assetPlaceHolder != null && assetPlaceHolder.isNotEmpty) {
    stream.add(AssetImage(assetPlaceHolder));
  }

  return stream;
}
