part of modern_form_files;

class ModernFormFileHelper {
  static String filePath = "";
  static Future<void> init() async {
    filePath = await getApplicationDocumentsDirectory();
  }

  static Future<Uint8List?> getFile(ModernFormFileExtensionType? type) async {
    return await ModernFormFilePlatformHelper.getFile(type);
  }

  static Future<void> openFileWithPath(String path) async {
    await ModernFormFilePlatformHelper.openFileWithPath(path);
  }

  static Future<void> openFileWithBytes(
      List<int> bytes, String? name, String type) async {
    await ModernFormFilePlatformHelper.openFileWithBytes(bytes, name, type);
  }

  static Future<String> getFilePathFromUrl(
      String originalUrl, String fileExtension) async {
    String url = getUrlFormatedToFilepath(originalUrl);

    return ModernFormFilePlatformHelper.getFilePathFromUrl(url, fileExtension);
  }

  static Future<String> getApplicationDocumentsDirectory() {
    return ModernFormFilePlatformHelper.getApplicationDocumentsDirectory();
  }

  static String getUrlFormatedToFilepath(String originalUrl) {
    String url = originalUrl;
    url = url.replaceAll("https:", "");
    url = url.replaceAll("/", "");
    url = url.replaceAll("_", "");
    url = url.replaceAll("=", "");
    url = url.replaceAll(".", "");
    url = url.replaceAll("-", "");
    url = url.replaceAll("&", "");
    url = url.replaceAll("%20", "");
    url = url.replaceAll("%2F", "");
    url = url.replaceAll(" ", "");
    url = url.replaceAll("?", "");

    if (url.length > fileNameMaxLenght) {
      url = url.substring(0, fileNameMaxLenght - 1);
    }

    return url;
  }

  static int fileNameMaxLenght = 251;
}
