part of modern_form_images;

class ModernFormImagePicker extends StatelessWidget {
  final String? label;
  final String? helperText;
  final void Function(XFile?)? onChanged;
  final void Function(String url)? onChangePaste;
  final Widget? child;
  final bool? enabled;
  final XFile? image;
  final Uint8List? imageMemory;
  final String? imageUrl;
  final String? Function(XFile?)? validator;
  final bool? pasteEnabled;

  const ModernFormImagePicker({
    Key? key,
    this.label,
    this.onChanged,
    this.child,
    this.enabled,
    this.image,
    this.validator,
    this.imageMemory,
    this.imageUrl,
    this.onChangePaste,
    this.pasteEnabled,
    this.helperText,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Text(label ?? "Imagem", style: ModernFormTextStyle.moderFormLabelStyle),
        helperText != null
            ? Padding(
                padding: EdgeInsets.only(top: ScreenUtil().setHeight(5)),
                child: Text(helperText ?? "",
                    style: ModernFormTextStyle.moderFormHelperStyle),
              )
            : SizedBox(),
        validator != null && validator!(image) != null
            ? Text(validator!(image) ?? "",
                style: ModernFormTextStyle.moderFormErrorStyle)
            : Container(),
        SizedBox(height: ScreenUtil().setHeight(2)),
        Padding(
          padding: EdgeInsets.all(ScreenUtil().setSp(8)),
          child: Row(
            children: [
              child == null
                  ? Padding(
                      padding:
                          EdgeInsets.only(right: ScreenUtil().setWidth(20)),
                      child: image != null
                          ? Container(
                              width: ScreenUtil().setWidth(80),
                              height: ScreenUtil().setWidth(100),
                              child: kIsWeb
                                  ? Image.network(image!.path)
                                  : Image.file(File(image!.path)),
                            )
                          : ModernFormViewImage(
                              network: imageUrl,
                              memory: imageMemory,
                              onDelete:
                                  (imageMemory != null && imageMemory!.isNotEmpty )&&onChanged!=null
                                      ? () {
                                          onChanged!(null);
                                        }
                                      : null,
                              width: ScreenUtil().setWidth(80),
                            ),
                    )
                  : child!,
              ModernFormUpload(
                onTap: (enabled ?? true)
                    ? () async {
                        ImageSource? imageSource = await ModernFormImageHelper
                            .showBottonSheetImageSource();
                        if (imageSource != null) {
                          XFile? pickedFile =
                              await ModernFormImageHelper.pickImage(
                                  imageSource);

                          if (pickedFile != null && onChanged != null) {
                            onChanged!(pickedFile);
                          }
                        }
                      }
                    : null,
                pasteEnabled: pasteEnabled,
                onChange: (enabled ?? true) ? onChangePaste : null,
              ),
            ],
          ),
        ),
      ],
    );
  }
}
