part of modern_form_images;

class ModernFormViewImages extends StatelessWidget {
  final List<String>? imagesUrl;
  final List<Uint8List>? imagesMemory;
  final Axis? direction;
  final void Function(int)? onDelete;
  final double? height;
  final double? width;

  const ModernFormViewImages({
    Key? key,
    this.imagesUrl,
    this.imagesMemory,
    this.direction,
    this.onDelete,
    this.height,
    this.width,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    bool isHorizontal = direction == null || direction == Axis.horizontal;
    bool isMemory = imagesMemory != null && imagesMemory!.isNotEmpty;

    return Container(
      height: isHorizontal ? ScreenUtil().setWidth(80) : null,
      child: ListView.builder(
        shrinkWrap: true,
        scrollDirection: direction ?? Axis.horizontal,
        physics: NeverScrollableScrollPhysics(),
        itemCount: isMemory ? imagesMemory?.length : imagesUrl?.length ?? 0,
        itemBuilder: (context, index) {
          String? imageUrl;
          Uint8List? imageMemory;
          if (index < (imagesMemory?.length ?? 0)) {
            imageMemory = imagesMemory![index];
          }
          if (index < (imagesUrl?.length ?? 0)) {
            imageUrl = imagesUrl![index];
          }

          return Padding(
            padding: EdgeInsets.only(
              right: isHorizontal ? ScreenUtil().setWidth(20) : 0,
              bottom: isHorizontal ? 0 : ScreenUtil().setHeight(20),
            ),
            child: ModernFormViewImage(
              network: imageUrl,
              memory: imageMemory,
              backgroundColor: isHorizontal ? Colors.white : Colors.transparent,
              elevation: isHorizontal ? 2 : 0,
              height: height,
              width: width,
              onDelete: onDelete == null
                  ? null
                  : () {
                      onDelete!(index);
                    },
            ),
          );
        },
      ),
    );
  }
}
