part of modern_form_videos;

class ModernFormYoutubeViewPlayer extends StatelessWidget {
  final String? url;
  final void Function(BuildContext context)? share;

  const ModernFormYoutubeViewPlayer({
    Key? key,
    required this.url,
    this.share,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Row(
      mainAxisAlignment: MainAxisAlignment.spaceEvenly,
      children: [
        ElevatedButton(
          style: ElevatedButton.styleFrom(
            primary: ModernFormUtils.secundaryColor,
          ),
          child: Text(
            "Abrir no Youtube",
            style: TextStyle(color: Colors.white),
          ),
          onPressed: () {
            launch(url!);
          },
        ),
        Builder(
          builder: (context) {
            return ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Theme.of(context).primaryColor,
              ),
              child: Text(
                "Compartilhar vídeo",
                style: TextStyle(color: Colors.white),
              ),
              onPressed: () {
                if (share != null) {
                  share!(context);
                }
              },
            );
          },
        ),
      ],
    );
  }
}
